require 'dbus'
require 'gtk2'
require 'gconf2'

class GConfService < DBus::Service
  def initialize
    super("org.gnome.GConf", DBus::SessionBus.new)
    gconf_object_tree = GConfObjectTree.new(self)
  end
    
  class GConfObjectTree < DBus::ObjectTree
    def initialize(service)
      super("/org/gnome/GConf", service, dbus_methods=[:getString, :setString, :getInt, :setInt])
      @client = GConf::Client.default
    end

    def get(message, object_path)
      puts "get called for GConf key %s" % object_path
      @client[object_path]
    end

    def set(message, object_path, new_value)
      puts "set called for GConf key %s" % object_path
      @client[object_path] = new_value
    end

    alias :getString :get
    alias :setString :set
    alias :getInt :get
    alias :setInt :set
  end
end
        
gconf_service = GConfService.new

puts "GConf Proxy service started."
puts "Run 'gconf-proxy-client.rb' to fetch a GConf key through the proxy..."

Gtk.main
